'BASE-VGA.INC fr PowerBasic ab Version 2.1
'Basis-Funktionen fr den VGA-Grafikmodus 13h (320 x 200 mit 256 Farben).
'Public Domain von Thiemo Mttig, Hauptstr. 11, 02627 Hochkirch

'----------------------------------------------------------------------------

sub VScreen (Modus%)					'Ersatz fr SCREEN
  select case Modus%
    case 0
      def seg						'Segment auf Null
      reg 1,&H0003: call interrupt &H10			'Textmodus 80x25 ein
      screen 0: width 80: cls				'nur zur Sicherheit
    case 13
      reg 1,&H0013: call interrupt &H10			'Modus 13h ein
      def seg=&HA000					'Segment einstellen
    case else
      def seg						'Segment auf Null
      screen Modus%					'anderer Modus
  end select
end sub

'----------------------------------------------------------------------------

sub VCls (Farbe%)					'Ersatz fr CLS
  def seg=&HA000					'neue Segmentadresse
  Temp$=string$(640,Farbe%)				'nur ein Hilfs-String
  for i%=0 to 99					'100 Schritte
    poke$ i%*640,Temp$					'Bildzeilen zeichnen
  next
end sub

'----------------------------------------------------------------------------

sub VPset (x%,y%,Farbe%)				'Ersatz fr PSET
  if x%<0 or x%>319 or y%<0 or y%>199 then exit sub	'Koordinaten prfen
  poke y%*320+x%,Farbe%					'Punkt setzen
end sub

'----------------------------------------------------------------------------

function VPoint% (x%,y%)				'Ersatz fr POINT
  VPoint%=peek(y%*320+x%)				'Punktfarbe lesen
end function

'----------------------------------------------------------------------------

sub VLine (x1%,y1%,x2%,y2%,f%,p%)			'Ersatz fr LINE
  if p%<1 then p%=1					'Schrittweite prfen
  lx%=x2%-x1%: ly%=y2%-y1%				'Berechne die Lnge
  lg%=sqr(lx%*lx%+ly%*ly%)				'der gesamten Linie.
  dx!=lx%/lg%: dy!=ly%/lg%
  for i%=0 to lg% step p%				'Zeichne Punkte mit
    call VPset(x1%+dx!*i%,y1%+dy!*i%,f%)		'der Farbe f%
  next
end sub

'----------------------------------------------------------------------------

sub VBox (x1%,y1%,x2%,y2%,f%,ff%)			'Ersetzt LINE(),B[F]
  if x1%>x2% then swap x1%,x2%
  if y1%>y2% then swap y1%,y2%
  if x1%<0 or x2%>319 or y1%<0 or y2%>199 then exit sub
  for i%=y1%+1 to y2%-1					'Zeichne die zwei
    call vpset(x1%,i%,f%): call vpset(x2%,i%,f%)	'vertikalen Linien.
  next
  poke$ 320*y1%+x1%,string$(x2%-x1%+1,f%)		'Zeichne horizon-
  poke$ 320*y2%+x1%,string$(x2%-x1%+1,f%)		'tale Linien.
  if ff%>-1 then					'Fllen?
    for i%=y1%+1 to y2%-1				'Flle Rechteck mit
      poke$ 320*i%+x1%+1,string$(x2%-x1%-1,ff%)		'der Farbe ff%.
    next
  end if
end sub

'----------------------------------------------------------------------------

sub VBoxGefuellt (x1%,y1%,x2%,y2%,f%)			'Ersatz fr LINE(),BF
  if x1%>x2% then swap x1%,x2%
  if y1%>y2% then swap y1%,y2%
  if x1%<0 or x2%>319 or y1%<0 or y2%>199 then exit sub
  for z%=y1% to y2%					'Zeichne Rechteck mit
    poke$ 320*z%+x1%,string$(x2%-x1%+1,f%)		'der Farbe f%.
  next
end sub

'----------------------------------------------------------------------------

sub VCircle (x%,y%,r%,Farbe%,s!,e!,a!,Schritt%)		'Ersatz fr CIRCLE
  if a!=0 then a!=.8					'normaler Kreis?
  if s!=e! then s!=0: e!=6.283				'Vollkreis?
  if Schritt%<1 then Schritt%=1				'Schrittweite prfen
  for i!=s! to e! step Schritt%/r%
    if a!>1 then					'senkrechte Ellipse
      nx%=r%*cos(i!)/a!: ny%=r%*sin(i!)			'Koordinaten rechnen
    else						'waagerechte Ellipse
      nx%=r%*cos(i!): ny%=r%*sin(i!)*a!			'Koordinaten rechnen
    end if
    call VPset(x%+nx%,y%-ny%,Farbe%)			'St% und der Farbe f%
  next
end sub

'----------------------------------------------------------------------------

sub VCircleGefuellt (x%,y%,r%,Farbe%,a!)		'ein gefllter Kreis
  if a!=0 then a!=.8					'normaler Aspekt
  if a!<1 then rz%=fix(r%*a!+.5) else rz%=r%		'vertikal gestaucht?
  for i%=0 to rz%
    if a!>1 then					'senkrechte Ellipse
      j%=sqr(r%*r%-(i%-.5)*(i%-.5))/a!			'Breite berechnen
    else						'waagerechte Ellipse
      j%=sqr(r%*r%-(i%-.5)*(i%-.5)/(a!*a!))		'Breite berechnen
    end if
    Temp$=string$(2*j%+1,Farbe%)			'nur ein Hilfs-String
    if y%-i%>=0 then poke$ (y%-i%)*320+x%-j%, Temp$	'obere Hlfte
    if y%+i%<200 then poke$ (y%+i%)*320+x%-j%, Temp$	'untere Hlfte
  next
end sub

'----------------------------------------------------------------------------

sub RGBLesen (Farbe%,r%,g%,b%)				'Palettenfarbe lesen
  out &H3C7,Farbe%					'Welche Farbe?
  r%=inp(&H3C9): g%=inp(&H3C9): b%=inp(&H3C9)		'RGB-Werte lesen
end sub

'----------------------------------------------------------------------------

sub RGBSetzen (Farbe%,r%,g%,b%)				'Palettenfarbe ndern
  out &H3C8,Farbe%					'Welche Farbe?
  out &H3C9,r%: out &H3C9,g%: out &H3C9,b%		'von 0 bis maximal 63
end sub
