'MAUS.INC fr PowerBasic ab Version 2.1
'Alle wichtigen Funktionen fr die Benutzung der Maus in eigenen Programmen.
'Public Domain von Thiemo Mttig, Hauptstr. 11, 02627 Hochkirch

'----------------------------------------------------------------------------

shared MausVorhanden%,MausX%,MausY%			'Globale Variablen
reg 1,0: call interrupt &H33				'Testen ob eine Maus
MausVorhanden%=reg(1)					'vorhanden ist

'----------------------------------------------------------------------------

sub MausEin						'Maus-Cursor ein
  if MausVorhanden% then				'wenn Maus vorhanden
    reg 1,1: call interrupt &H33
  end if
end sub

'----------------------------------------------------------------------------

sub MausAus						'Maus-Cursor aus
  if MausVorhanden% then				'wenn Maus vorhanden
    reg 1,2: call interrupt &H33
  end if
end sub

'----------------------------------------------------------------------------

sub MausCursor (t%, v%, h%, z%)				'Text-Cursor ndern
  if MausVorhanden% then				'wenn Maus vorhanden
    select case t%					'10 sind vordefiniert
      case 1						'Zeichen mit V und H
        reg 3,0: reg 4,256*(16*h%+v%)+z%
      case 2						'Zeichen mit V
        reg 3,112*256: reg 4,256*v%+z%
      case 3						'Zeichen Hell
        reg 3,247*256: reg 4,256*8+z%
      case 4						'nur Zeichen
        reg 3,255*256: reg 4,z%
      case 5						'alle Farben
        reg 3,255: reg 4,256*(16*h%+v%)
      case 6						'V setzen, H mit xor
        reg 3,256*240+255: reg 4,256*(112+v%)
      case 7						'nur Hintergrund
        reg 3,143*256+255: reg 4,256*(16*h%)
      case 8						'V hell, H mit xor
        reg 3,247*256+255: reg 4,256*120
      case 9						'V lassen, H mit xor
        reg 3,255*256+255: reg 4,256*112
      case else						'V und H mit xor
        reg 3,255+119*256: reg 4,119*256
    end select
    reg 2,0: reg 1,10: call interrupt &H33
  end if
  'Hinweis: 1+1=xor, 0+1=immer an, 1+0=so lassen, 0+0=immer aus
  'Siehe auch Ralf Browns Interrupt Liste!
end sub

'----------------------------------------------------------------------------

sub MausAusschluss (x1%, y1%, x2%, y2%)			'Ausschlubereich
  if MausVorhanden% then				'wenn Maus vorhanden
    reg 1,&HF00: call interrupt &H10			'Videomodus lesen
    select case reg(1) and 255
      case 0, 1
        reg 3,(y1%-1)*16: reg 4,(x1%-1)*8
        reg 5,(y2%-1)*16: reg 6,(x2%-1)*8
      case 2, 3
        reg 3,(y1%-1)*8: reg 4,(x1%-1)*8
        reg 5,(y2%-1)*8: reg 6,(x2%-1)*8
      case 4
        reg 3,x1%*2: reg 4,y1%: reg 5,x2%*2: reg 6,y2%
      case else
        reg 3,x1%: reg 4,y1%: reg 5,x2%: reg 6,y2%
    end select
    reg 1,&H10: call interrupt &H33			'Bereich setzen
  end if
end sub

'----------------------------------------------------------------------------

function Clicked%					'Maus-Taste gedrckt?
  if MausVorhanden% then				'wenn Maus vorhanden
    reg 1,&HF00: call interrupt &H10			'Grafikmodus lesen
    VideoMode%=reg(1) and 255
    reg 1,3: call interrupt &H33
    Clicked%=reg(2)					'Maustasten lesen
    select case VideoMode%				'abhngig vom Modus
      case 0, 1
        MausX%=reg(4)\8+1: MausY%=reg(3)\16+1
      case 2, 3
        MausX%=reg(4)\8+1: MausY%=reg(3)\8+1
      case 4, 9, &H0D, &H13
        MausX%=reg(3)\2: MausY%=reg(4)
      case else
        MausX%=reg(3): MausY%=reg(4)
    end select
  end if
end function

'----------------------------------------------------------------------------

sub MausUndTasten (PressKey$, MsTst%, DClick%)		'Lies Maus & Tasten
  static Press1!, OldMsTst%, OldMausX%, OldMausY%	'Statische Variablen
  PressKey$="": MsTst%=0
  while PressKey$="" and MsTst%=0			'auf Eingabe warten
    PressKey$=inkey$: MsTst%=Clicked%
  wend
  if Press1!+.6>timer and OldMsTst%=MsTst% and _	'Doppelklick?
    OldMausX%=MausX% and OldMausY%=MausY% then
    DClick%=1:Press1!=0
  else							'erster Mausklick
    DClick%=0: Press1!=timer
    OldMsTst%=MsTst%: OldMausX%=MausX%: OldMausY%=MausY%
  end if
end sub

'----------------------------------------------------------------------------

sub WarteAufMaus					'Warte, bis alle
  if MausVorhanden% then				'Maustasten losge-
    while reg(2)>0					'lassen wurden.
      reg 1,3 : call interrupt &H33
    wend
  end if
end sub

'----------------------------------------------------------------------------

sub LocateMaus (x%, y%)					'Maus positionieren
  if MausVorhanden% then				'(so wie LOCATE)
    reg 1,&HF00: call interrupt &H10			'Grafikmodus lesen
    select case reg(1) and 255
      case 0, 1
	if x%<1 then x%=13				'Sicherheitsabfragen
	if y%<1 then y%=20				'und Register setzen
	reg 4,8*(x%-1): reg 3,16*(y%-1)			'abhngig vom Grafik-
      case 2, 3						'modus
	if x%<1 then x%=13
	if y%<1 then y%=40
	reg 4,8*(x%-1): reg 3,8*(y%-1)
      case &H11, &H12
        if x%>639 then x%=319
        if y%>479 then y%=239
        reg 3,x%: reg 4,y%
      case 1, 7, &H13
        if x%>319 then x%=159
        if y%>199 then y%=99
        reg 3,x%*2: reg 4,y%
      case else
        reg 3,x%: reg 4,y%
    end select
    reg 1,4: call interrupt &H33			'Interrupt aufrufen
  end if
end sub

'----------------------------------------------------------------------------

sub MausGrenzen (x1%, y1%, x2%, y2%)			'Grenzen fr die
  if MausVorhanden% then				'Bewegung der Maus
    reg 1,&HF00: call interrupt &H10			'Grafikmodus lesen
    select case reg(1) and 255
      case 0, 1
        if x1%<1 then x1%=1
        if y1%<1 then y1%=1
        if x2%<1 then x2%=25
        if y2%<1 then y2%=40
        reg 1,8: reg 3,8*(x1%-1): reg 4,8*(x2%-1): call interrupt &H33
        reg 1,7: reg 3,16*(y1%-1): reg 4,16*(y2%-1)
      case 2, 3
        if x1%<1 then x1%=1
        if y1%<1 then y1%=1
        if x2%<1 then x2%=25
        if y2%<1 then y2%=80
        reg 1,8: reg 3,8*(x1%-1): reg 4,8*(x2%-1): call interrupt &H33
        reg 1,7: reg 3,8*(y1%-1): reg 4,8*(y2%-1)
      case 1, 7, &H13
        if x1%<0 then x1%=0
        if y1%<0 then y1%=0
        if x2%<1 then x2%=319
        if y2%<1 then y2%=199
        reg 1,7: reg 3,2*x1%: reg 4,2*x2%: call interrupt &H33
        reg 1,8: reg 3,y1%: reg 4,y2%
      case &H11, &H12
        if x1%<0 then x1%=0
        if y1%<0 then y1%=0
        if x2%<1 then x2%=639
        if y2%<1 then y2%=479
        reg 1,7: reg 3,x1%: reg 4,x2%: call interrupt &H33
        reg 1,8: reg 3,y1%: reg 4,y2%
    end select
    call interrupt &H33					'zwei Interrupts sind
  end if						'notwendig (x und y)
end sub

'----------------------------------------------------------------------------

sub WarteAufTasteOderMaus				'Wartet auf eine
  while inkey$<>"": wend: call WarteAufMaus		'beliebige Taste
  while inkey$=""					'(auch Maustasten)
    if Clicked% then exit loop
  wend							'gibt Nichts zurck
end sub
